Index: /LMDZ4/trunk/libf/dyn3dpar/initdynav_p.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/initdynav_p.F	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/initdynav_p.F	(revision 1000)
@@ -70,4 +70,17 @@
       integer zan, dayref
       integer :: jjb,jje,jjn
+
+! definition du domaine d'ecriture pour le rebuild
+
+      INTEGER,DIMENSION(2) :: ddid
+      INTEGER,DIMENSION(2) :: dsg
+      INTEGER,DIMENSION(2) :: dsl
+      INTEGER,DIMENSION(2) :: dpf
+      INTEGER,DIMENSION(2) :: dpl
+      INTEGER,DIMENSION(2) :: dhs
+      INTEGER,DIMENSION(2) :: dhe 
+      
+      INTEGER :: dynave_domain_id
+      
       
       if (adjust) return
@@ -95,9 +108,19 @@
       jje=jj_end
       jjn=jj_nb
+
+      ddid=(/ 1,2 /)
+      dsg=(/ iip1,jjp1 /)
+      dsl=(/ iip1,jjn /)
+      dpf=(/ 1,jjb /)
+      dpl=(/ iip1,jje /)
+      dhs=(/ 0,0 /)
+      dhe=(/ 0,0 /)
+
+      call flio_dom_set(mpi_size,mpi_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, 
+     .                 'box',dynave_domain_id)
              
-      call histbeg(trim(infile)//'_'//trim(int2str(mpi_rank))//'.nc',
-     .             iip1, rlong(:,1), jjn, rlat(1,jjb:jje),
-     .             1, iip1, 1, jjn,
-     .             tau0, zjulian, tstep, thoriid, fileid)
+      call histbeg(trim(infile),iip1, rlong(:,1), jjn, rlat(1,jjb:jje),
+     .             1, iip1, 1, jjn,tau0, zjulian, tstep, thoriid,
+     .             fileid,dynave_domain_id)
 
 C
Index: /LMDZ4/trunk/libf/dyn3dpar/initfluxsto_p.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/initfluxsto_p.F	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/initfluxsto_p.F	(revision 1000)
@@ -74,4 +74,19 @@
       logical ok_sync
       integer :: jjb,jje,jjn
+
+! definition du domaine d'ecriture pour le rebuild
+
+      INTEGER,DIMENSION(2) :: ddid
+      INTEGER,DIMENSION(2) :: dsg
+      INTEGER,DIMENSION(2) :: dsl
+      INTEGER,DIMENSION(2) :: dpf
+      INTEGER,DIMENSION(2) :: dpl
+      INTEGER,DIMENSION(2) :: dhs
+      INTEGER,DIMENSION(2) :: dhe 
+      
+      INTEGER :: dynu_domain_id
+      INTEGER :: dynv_domain_id
+
+
 C
 C  Initialisations
@@ -100,9 +115,19 @@
       jje=jj_end
       jjn=jj_nb
+
+      ddid=(/ 1,2 /)
+      dsg=(/ iip1,jjp1 /)
+      dsl=(/ iip1,jjn /)
+      dpf=(/ 1,jjb /)
+      dpl=(/ iip1,jje /)
+      dhs=(/ 0,0 /)
+      dhe=(/ 0,0 /)
+
+      call flio_dom_set(mpi_size,mpi_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, 
+     .                 'box',dynu_domain_id)
        
-      call histbeg(trim(infile)//'_'//trim(int2str(mpi_rank))//'.nc',
-     .             iip1, rlong(:,1), jjp1, rlat(1,jjb:jje),
-     .             1, iip1, 1, jjn,
-     .             tau0, zjulian, tstep, uhoriid, fileid)
+      call histbeg(trim(infile),iip1, rlong(:,1), jjn, rlat(1,jjb:jje),
+     .             1, iip1, 1, jjn, tau0, zjulian, tstep, uhoriid,
+     .             fileid,dynu_domain_id)
 C
 C  Creation du fichier histoire pour la grille en V (oblige pour l'instant,
@@ -124,8 +149,18 @@
       if (pole_sud) jjn=jj_nb-1
 
-      call histbeg('fluxstokev_'//trim(int2str(mpi_rank))//'.nc',
-     .             iip1, rlong(:,1), jjm, rlat(1,jjb:jje),
-     .             1, iip1, 1, jjn,
-     .             tau0, zjulian, tstep, vhoriid, filevid)
+      ddid=(/ 1,2 /)
+      dsg=(/ iip1,jjm /)
+      dsl=(/ iip1,jjn /)
+      dpf=(/ 1,jjb /)
+      dpl=(/ iip1,jje /)
+      dhs=(/ 0,0 /)
+      dhe=(/ 0,0 /)
+
+      call flio_dom_set(mpi_size,mpi_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, 
+     .                 'box',dynv_domain_id)
+     
+      call histbeg('fluxstokev',iip1, rlong(:,1), jjn, rlat(1,jjb:jje),
+     .             1, iip1, 1, jjn,tau0, zjulian, tstep, vhoriid,
+     .             filevid,dynv_domain_id)
 	
       rl(1,1) = 1.	
Index: /LMDZ4/trunk/libf/dyn3dpar/inithist_p.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/inithist_p.F	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/inithist_p.F	(revision 1000)
@@ -70,4 +70,17 @@
       integer zan, dayref
       integer :: jjb,jje,jjn
+
+! definition du domaine d'ecriture pour le rebuild
+
+      INTEGER,DIMENSION(2) :: ddid
+      INTEGER,DIMENSION(2) :: dsg
+      INTEGER,DIMENSION(2) :: dsl
+      INTEGER,DIMENSION(2) :: dpf
+      INTEGER,DIMENSION(2) :: dpl
+      INTEGER,DIMENSION(2) :: dhs
+      INTEGER,DIMENSION(2) :: dhe 
+      
+      INTEGER :: dynu_domain_id
+      INTEGER :: dynv_domain_id
 C
 C  Initialisations
@@ -95,9 +108,20 @@
       jje=jj_end
       jjn=jj_nb
-      
-       call histbeg(trim(infile)//'_'//trim(int2str(mpi_rank))//'.nc',
-     .             iip1, rlong(:,1), jjn, rlat(1,jjb:jje),
-     .             1, iip1, 1, jjn,
-     .             tau0, zjulian, tstep, uhoriid, fileid)
+
+
+      ddid=(/ 1,2 /)
+      dsg=(/ iip1,jjp1 /)
+      dsl=(/ iip1,jjn /)
+      dpf=(/ 1,jjb /)
+      dpl=(/ iip1,jje /)
+      dhs=(/ 0,0 /)
+      dhe=(/ 0,0 /)
+
+      call flio_dom_set(mpi_size,mpi_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, 
+     .                 'box',dynu_domain_id)
+      
+       call histbeg(trim(infile),iip1, rlong(:,1), jjn, 
+     .              rlat(1,jjb:jje), 1, iip1, 1, jjn, tau0,
+     .              zjulian, tstep, uhoriid, fileid,dynu_domain_id)
 C
 C  Creation du fichier histoire pour la grille en V (oblige pour l'instant,
@@ -117,9 +141,19 @@
       if (pole_sud) jje=jj_end-1
       if (pole_sud) jjn=jj_nb-1
-      
-      call histbeg('dyn_histv_'//trim(int2str(mpi_rank))//'.nc', 
-     .             iip1, rlong(:,1), jjn, rlat(1,jjb:jje),
-     .             1, iip1, 1, jjn,
-     .             tau0, zjulian, tstep, vhoriid, filevid)
+
+      ddid=(/ 1,2 /)
+      dsg=(/ iip1,jjm /)
+      dsl=(/ iip1,jjn /)
+      dpf=(/ 1,jjb /)
+      dpl=(/ iip1,jje /)
+      dhs=(/ 0,0 /)
+      dhe=(/ 0,0 /)
+
+      call flio_dom_set(mpi_size,mpi_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, 
+     .                 'box',dynv_domain_id)
+      
+      call histbeg('dyn_histv', iip1, rlong(:,1), jjn, rlat(1,jjb:jje),
+     .             1, iip1, 1, jjn, tau0, zjulian, tstep, vhoriid, 
+     .             filevid,dynv_domain_id)
 C
 C  Appel a histhori pour rajouter les autres grilles horizontales
Index: /LMDZ4/trunk/libf/dyn3dpar/leapfrog_p.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/leapfrog_p.F	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/leapfrog_p.F	(revision 1000)
@@ -76,5 +76,4 @@
 #include "advtrac.h"
       
-      include 'mpif.h'
       integer nq
 
@@ -237,8 +236,6 @@
 c$OMP MASTER
 
-!$OMP CRITICAL (MPI)
-      call MPI_BARRIER(COMM_LMDZ,ierr)
-!$OMP END CRITICAL (MPI)
-
+      CALL barrier
+      
 c$OMP END MASTER
 c$OMP BARRIER
@@ -736,5 +733,4 @@
         call Register_SwapFieldHallo(flxw,flxw,ip1jmp1,llm,
      *                               jj_Nb_physic,2,2,Request_physic)
-        call SetDistrib(jj_nb_Physic)
         
         call SendRequest(Request_Physic)
@@ -853,4 +849,8 @@
 c      ajout des tendances physiques:
 c      ------------------------------
+         IF (ok_strato) THEN
+           CALL top_bound_p( vcov,ucov,teta, dufi,dvfi,dtetafi)
+         ENDIF
+       
           CALL addfi_p( nqmx, dtphys, leapf, forward   ,
      $                  ucov, vcov, teta , q   ,ps ,
@@ -1289,4 +1289,5 @@
 c$OMP BARRIER
               call WaitRequest(TestRequest)
+c$OMP BARRIER
 c$OMP MASTER
               CALL writedynav_p(histaveid, nqmx, itau,vcov ,
@@ -1340,16 +1341,5 @@
         CALL writehist_p(histid,histvid, nqmx,itau,vcov, 
      s                       ucov,teta,phi,q,masse,ps,phis)
-c#else
-c       call Gather_Field(unat,ip1jmp1,llm,0)
-c       call Gather_Field(vnat,ip1jm,llm,0)
-c       call Gather_Field(teta,ip1jmp1,llm,0)
-c       call Gather_Field(ps,ip1jmp1,1,0)
-c       do iq=1,nqmx
-c        call Gather_Field(q(1,1,iq),ip1jmp1,llm,0)
-c       enddo
-c      
-c       if (mpi_rank==0) then
-c#include "write_grads_dyn.h"
-c       endif
+
 #endif
 c$OMP END MASTER
@@ -1445,4 +1435,5 @@
               call WaitRequest(TestRequest)
 
+c$OMP BARRIER
 c$OMP MASTER
               CALL writedynav_p(histaveid, nqmx, itau,vcov ,
